﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc {
  using Base.Erc.Interfaces;
  using Common;
  using Core;
  using Data;
  using Parameters;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public abstract class ErcOption : ParameterizedNamedItem, IReadOnlyErcOption {
    private const string IsEnabledParameterName = "IsEnabled";

    protected ErcOption() {
      Parameters.Add(new FixedValueParameter<BoolValue>(IsEnabledParameterName));
    }

    [StorableConstructor]
    protected ErcOption(bool deserializing) : base(deserializing) { }

    protected ErcOption(ErcOption origin, Cloner cloner) : base(origin, cloner) { }

    public IValueParameter<BoolValue> IsEnabledParameter
    {
      get { return (IValueParameter<BoolValue>)Parameters[IsEnabledParameterName]; }
    }

    public bool IsEnabled
    {
      get { return IsEnabledParameter.Value.Value; }
      set { IsEnabledParameter.Value.Value = value; }
    }
  }
}
